CCDictWrapper {
	var <>keys, <>values;
	
	*new { arg dict;
		^super.new.initWithDict(dict);
	}
	
	initWithDict { arg dict;
		keys = Array.new(dict.size);
		values = Array.new(dict.size);
		dict.keysValuesDo { |key, val| keys.add(key); values.add(val); };
	}
}

/* 
 * the whole deferal system is really ugly and hopefully is only temporary.
 * if not, it needs to be reworked 
 */

CCTrampoline {
	var objcInstance, <finalizer, deferType, deferNum;
	classvar deferFunctions, deferFunctionsLastIdx;
	
	*initClass {
		deferFunctions = List.newClear(128);
		deferFunctionsLastIdx = 0;
	}
	
	*respondsTo { arg aSymbol;
		_ObjC_RespondsTo
		^this.primitiveFailed;
	}
	
	respondsTo { arg aSymbol;
		_ObjC_RespondsTo
		^this.primitiveFailed;	
	}
	
	defer { arg callBack;
		this.setupDefer(callBack, 1);
	}

	*defer { arg callBack;
		^super.new.setupDefer(callBack, 2);
	}
	
	// nil callBack can be handled more efficiently
	setupDefer { arg callBack, type;
		var obj;
		deferType = type;
		deferNum = deferFunctionsLastIdx;
		
		if(type == 1) {obj = this} {obj = this.class};
		deferFunctions[deferFunctionsLastIdx] = [callBack, obj, type];
		deferFunctionsLastIdx = deferFunctionsLastIdx + 1;
	}
	
	*deferedCallBack { arg num, ret;
		var item = deferFunctions[num];

		item[0].value(ret, item[1], item[2]);
		
		deferFunctions[num] = nil;
		deferFunctionsLastIdx = deferFunctionsLastIdx - 1;
	}

	*doesNotUnderstand { arg selector ... args;
		var className = this.class.asString;
		^CCTrampoline.prInvoke(className[5..className.size], true, selector.asString, args, nil, this, -1);
	}

	doesNotUnderstand { arg selector ... args;
		var origDeferType = deferType, origDeferNum = deferNum;
		deferType = 0;
		deferNum = -1;
		//[origDeferType, origDeferNum].postln;
		^CCTrampoline.prInvoke(this.className, (origDeferType == 2), selector.asString, args, objcInstance, this, origDeferNum);
	}
	
	*prInvoke { arg className, isClassMethod, method, args, objcInstance, receiver, deferNum;
		var keyEnumerator, valueEnumerator, key, value;
		var ret;
	
		args.do({ arg x, index;
			if(x.isKindOf(Dictionary), {
				args[index] = CCDictWrapper.new(x);
			});
		});
		
		// should just grab deferNum and objcInstance from the object
		ret = CCTrampoline.prInvokeReal(className, isClassMethod, method, args, objcInstance, deferNum);
		
		if(ret.isKindOf(NSCFDictionary)) {
			keyEnumerator = ret.keyEnumerator; 
			valueEnumerator = ret.objectEnumerator;
			ret = CCDictionary(ret.count);
			
			while({key = keyEnumerator.nextObject; value = valueEnumerator.nextObject; (key != nil)},
			{ret.add(key->value)});
		};

		^ret
	}
	
	*prInvokeReal { arg className, isClassMethod, method, args, objcInstance, deferNum;
		_ObjC_Invoke
		^this.primitiveFailed;
	}
	
	*loadNib { arg fileName;
		var topLevelObjects = List.new(3);
		
		NSBundle.defer({ |ret|
			if(ret != true) {
				"Could not load NIB".postln;
			} {
				Library.put(\topLevelNibObjects, fileName.asSymbol, topLevelObjects);
			};
		}).loadNibFile_externalNameTable_withZone_(fileName, Dictionary[CCConstant("NSNibTopLevelObjects")->topLevelObjects], nil);
	}
	
	*topLevelObjects { arg fileName;
		^Library.at(\topLevelNibObjects, fileName.asSymbol);
	}
}