NSArrayTest : UnitTest {
	var array, testArray;

	setUp {
		testArray = List["zero","one","two","three"];
		array = NSMutableArray.arrayWithArray_(["zero","one","two","three"]);
	}
	
	testAt {
		this.assertEquals(array[0], testArray[0], format("array[0] should be \"%\", is \"%\"", testArray[0], array[0]));
	}

	testDo {
		var i = 0;
		
		array.do({ |item,index|
			this.assertEquals(item, testArray[index], format("array[%] should be \"%\", is \"%\"", index, testArray[index], item));
			i = i + 1;
		});
		
		if(i != testArray.size) {
			this.fail(format("array.do ran % times, should have ran % times", i, testArray.size));
		};
	}
	
	testAdd {
		array.add("four");
		this.assertEquals(array[4], "four", format("array[4] should be \"four\", is \"%\"", array[0]));	}
		
	testRemove {
		array.remove("one");
		testArray.remove("one");
		
		array.do({ |item,index|
			this.assertEquals(item, testArray[index], format("array[%] should be \"%\", is \"%\"", index, testArray[index], item));
		});	
	}
}