CCArray : SequenceableCollection {
	var <>ocArray;

	*new { arg size = 8;
		^super.new.ocArray_(NSMutableArray.arrayWithCapacity_(size));
	}
	*newClear { arg size = 0;
		if (size == 0, {
			^this.new;
		},{
			^this.new(size).insertBlanks(size);
		});
	}
	*copyInstance { arg aCCArray;
		^super.new.ocArray_(aCCArray.ocArray.copy);
	}
	*newUsing { |ocArray|
		^super.new.ocArray_(ocArray);
	}
	
	insertBlanks { arg num = 0;
		num.do({
			this.add(NSNull.null);
		});
	}
	
	size {
		^ocArray.count;
	}

	at { |x|
		^ocArray.objectAtIndex_(x);
	}
	
	put { arg i, item;
		^ocArray.replaceObjectAtIndex_withObject_(i, item);
	}
	
	add { |item|
		ocArray.addObject_(item);
	}
	
	removeAt { |index|
		var ret = this[index];
		ocArray.removeObjectAtIndex_(index);
		^ret;
	}
	
	do { |function|
		var enumerator = ocArray.objectEnumerator, object, i = 0;
		while({(object = enumerator.nextObject) != nil}) {
			(object + "face").postln;
			function.value(object, i);
			i = i + 1;
		};
	}
}